from car_util import * # yeahhh don't do this

############
# centre airbox
############

def airbox_pts(t, offs):
    # base of airbox
    base = []
    for j, _wd in enumerate([-wpoints[1], wpoints[1]]):
        p = []
        base.append(p)
        fl = copy(middle_fwd)
        fl.reverse()
        for i, d in enumerate(fl[:-1]):
            wd = _wd
            if i == 1:
                d += 0.15
            d += 0.05 # adjust base airbox back a bit
            if i == len(fl)-2:
                if j == 1:
                    wd += 0.06
                else:
                    wd -= 0.06
            pos = [wd + offs[0], d + offs[1], h1 + offs[2]]
            p.append(pos)
            if i != 2:
                t.add_joint(pos)

    # top of airbox
    top = []
    for j, wd in enumerate([-wpoints[1], wpoints[1]]):
        p = []
        top.append(p)
        fl = copy(middle_fwd)
        fl.reverse()
        for i, d in enumerate(fl[:-1]):
            height = h2
            if i == 0:
                d += 0.1
                height += 0.07 # lift back of airbox up, near rear seat
            if i == 1:
                d += 0.25
            if i == len(fl)-2:
                d -= 0.1
                height -= 0.03
            pos = [wd + offs[0], d + offs[1], height + offs[2]]
            p.append(pos)
            if i != 2:
                t.add_joint(pos)

    return base, top


class Airbox(Group):

    def __init__(self):
        Group.__init__(self)
        self.dflt_pipe_diam = dthin

    def make(self, bonnetpts, floorpts, fpoints, offs):
        bbase, bscoop = bonnetpts
        base, top = airbox_pts(self, offs)

        # vertical pipes, upright
        for i in range(len(base)):
            p = base[i]
            for j in [0, 1, len(p)-1]:
                diam = dthin
                offs1 = AUTO
                if j == 0:
                    diam = dthick
                if j == len(p)-1:
                    if i == 0:
                        offs1 = jrfu
                    if i == 1:
                        offs1 = jlfu
                self.add_pipe(p[j], top[i][j], diam, offs1)

        # vertical pipes, diagonal
        for i in range(len(base)):
            p = base[i]
            for j in [1]:
                self.add_pipe(p[j-1], top[i][j])

        for fpts in (base, top):
            # horizontal pipes, front-wise
            for i in range(len(fpts)):
                p = fpts[i]
                for j in [0]:
                    diam = dthin
                    offs1, offs2 = AUTO, AUTO
                    if fpts == top and j == 0:
                        # move joint-point slightly outwards
                        # only on top row, at back, near backbox and roof
                        if i == 0:
                            offs1 = jfrotr
                        if i == 1:
                            offs1 = jfrotl
                    self.add_pipe(p[j], p[j+1], diam, offs1, offs2)

            # horizontal pipes, width-wise
            for i in range(len(fpts)-1):
                p = fpts[i]
                for j in [0, 1, len(fpts[0])-1]:
                    diam = dthin
                    # windscreen pipe: make thicker
                    if fpts == top and j == len(fpts[0])-1:
                        diam = dthick
                    # and the top-most rear line
                    if fpts == top and j == 0:
                        diam = dthick
                    self.add_pipe(fpts[i][j], fpts[i+1][j], diam)

        # diagonals across front and back
        for j in [0, 1, len(top)-1]:
            self.add_pipe(top[0][j], base[1][j])

        # under roof diagonal
        for fpts in (base, top):
            self.add_pipe(fpts[1][0], fpts[0][1])

        # join to bonnet
        for fpts, topts, off, in ((base, bbase, 1), (top, bscoop, 0)):
            for i in range(len(fpts)):
                self.add_pipe(fpts[i][-1], topts[i+off][0])
            for i in range(len(base)-1):
                if i == 0:
                    offs1, offs2 = AUTO, AUTO
                    if off == 0:
                        offs1 = jfd #jrfd3
                        offs2 = jlbd3
                    self.add_pipe(fpts[i][-1], topts[i+off+1][0],
                                  dthin, offs1, offs2)
                else:
                    self.add_pipe(fpts[i+1][-1], topts[i+off][0])


        # diagonal joins to bonnet
        for i in range(len(bscoop)):
            self.add_pipe(base[i][-1], bscoop[i][0])

        ### now air-box to floor

        # join to floor
        for i in range(len(base)):
            p = base[i]
            for j in [0, 1, len(p)-1]:
                self.add_pipe(p[j], floorpts[i+1][j])

        # join driver seat diagonal-front to floor
        for i in [0, 1]:
            self.add_pipe(base[i][1], floorpts[i+1][0], dthin, AUTO, jfu)

        # join across to front section
        for i in [1,2]:
            self.add_pipe(floorpts[i][-1], bbase[i][0])
        self.add_pipe(fpoints[1][0], base[1][-1], dthin, jbu, AUTO)

        # and at rear
        self.add_pipe(floorpts[1][0], base[1][0])
        self.add_pipe(floorpts[1][1], base[1][1])

        return [base, top], self

